/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.162 by jmc, Wed May 11 01:51:07 2011 UTC revision 1.188 by jmc, Fri Jul 19 18:49:33 2013 UTC
# Line 15  usage() Line 15  usage()
15      echo "  (-mpi)                   use MPI to compile and run on 2 processors"      echo "  (-mpi)                   use MPI to compile and run on 2 processors"
16      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"
17      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"
18      echo "  (-ieee/-noieee)          if possible, use IEEE compiler flags"      echo "  (-fast)                  use optfile default for compiler flags (no '-ieee')"
19      echo "                             (DEF=\"-ieee\")"      echo "                            DEF=off => use IEEE numerics option (if available)"
20        echo "  (-devel)                 use optfile developement flags (if available)"
21      echo "  (-gsl)                   compile with \"-gsl\" flag"      echo "  (-gsl)                   compile with \"-gsl\" flag"
22      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"
23      echo "  (-optfile|-of) STRING    list of optfiles to use"      echo "  (-optfile|-of) STRING    list of optfiles to use"
# Line 34  usage() Line 35  usage()
35      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"
36      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
37      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
38        echo "  (-tlm)                   perform a Tangent Linear run"
39      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
40      echo "  (-oad)                   perform an OpenAD adjoint run"      echo "  (-oad)                   perform an OpenAD adjoint run"
41      echo "  (-command|-c) STRING     command to run"      echo "  (-command|-c) STRING     command to run"
# Line 47  usage() Line 49  usage()
49      echo "  (-match) NUMBER          Matching Criteria (number of digits)"      echo "  (-match) NUMBER          Matching Criteria (number of digits)"
50      echo "                             (DEF=\"$MATCH_CRIT\")"      echo "                             (DEF=\"$MATCH_CRIT\")"
51      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
52        echo "  (-ef) STRING             used as genmake2 \"-extra_flag\" argument"
53      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"
54      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
55        echo "  (-obj)                   only produces objects (=norun & no executable)"
56      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"
57      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
58      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
# Line 114  testoutput_var() Line 118  testoutput_var()
118      # testoutput_var dir s1 label subdir reference_output      # testoutput_var dir s1 label subdir reference_output
119      #      #
120      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
121      #     with same output from reference file $dir/results/$reference_output      #     with same output from reference file $dir/$reference_output
122      #  using search strings s1 and text label      #  using search strings s1 and text label
123    
124      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
# Line 127  testoutput_var() Line 131  testoutput_var()
131              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
132                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
133              fi              fi
134              return 99              rm -f tmp1.txt ; return 99
135          fi          fi
136      else      else
137          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
138          return 99          return 99
139      fi      fi
140      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
141          echo testoutput_var: grep "$2" $1/results/$5 1>&2          echo testoutput_var: grep "$2" $1/$5 1>&2
142      fi      fi
143      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/$5 | sed 's/.*=//' | cat -n > tmp2.txt
144      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
145      if [ $lncntB -lt 2 ]; then      if [ $lncntB -lt 2 ]; then
146          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
147              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
148          fi          fi
149          return 99          rm -f tmp1.txt tmp2.txt ; return 99
150      fi      fi
151      if [ $lncntA -ne $lncntB ]; then      if [ $lncntA -ne $lncntB ]; then
152          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
153              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
154          fi          fi
155          return 99          rm -f tmp1.txt tmp2.txt ; return 99
156      fi      fi
157      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat tmp1.txt | grep -i nan | wc -l`
158      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
159          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
160          return 99          rm -f tmp1.txt tmp2.txt ; return 99
161      fi      fi
162      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat tmp1.txt | grep -i inf | wc -l`
163      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
164          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
165          return 99          rm -f tmp1.txt tmp2.txt ; return 99
166      fi      fi
167      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
168          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
# Line 195  testoutput_run() Line 199  testoutput_run()
199      #      #
200      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
201  # --> same processing for adjoint & forward test  # --> same processing for adjoint & forward test
202          # default list of output variables to be checked:          # default list of output variables to be checked:
203          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
204          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
205          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
206          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
207          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
208          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
209          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
210          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
211                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
212          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
213          # check for ptracer output in reference_output file :          # set ref.outp file-name and, if compressed, uncompress it into subdir
214          outpref=$1/results/$3          refoutp=results/$3
215          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"          if test ! -r $1/results/$3 ; then
216          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"            if test -r $1/results/${3}.gz ; then
217          for ii in $PTRACERS_NUM ; do              tmpNam1=$3
218                tmpNam2=`echo $tmpNam1 | sed 's/\..*\././'`
219                if test "x$tmpNam1" = "x$tmpNam2" ; then
220                    tmpNam1=`echo $tmpNam2 | sed 's/\./.std./'`
221                fi
222                refoutp=$2/$tmpNam1
223                if [ $debug -gt 0 ]; then
224                    echo "testoutput_run: gunzip 'results/$3.gz' into '$refoutp'" 1>&2
225                fi
226                gzip -cd $1/results/${3}.gz > $1/$refoutp
227              else
228                echo "missing reference output file '$3' (.gz) in '$1/results/'"
229              fi
230            fi
231            # check for ptracer output in reference_output file :
232            if test $KIND = 0 ; then
233              ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
234              ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
235              for ii in $PTRACERS_NUM ; do
236              ptrfound=0              ptrfound=0
237              for jj in $ptr_mon ; do              for jj in $ptr_mon ; do
238                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
239                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`                  tst=`grep $name $1/$refoutp | wc -l | awk '{print $1}'`
240                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
241              done              done
242              if test $ptrfound = '1' ; then              if test $ptrfound = '1' ; then
243                  eval "HAVE_PTR0"$ii"=t"                  eval "HAVE_PTR0"$ii"=t"
244              else              else
245                  eval "HAVE_PTR0"$ii"=f"                  eval "HAVE_PTR0"$ii"=f"
               if test "x$ADM" = x -a "x$OADM" = x; then  
246                # remove this ptr from the list of output variable to check                # remove this ptr from the list of output variable to check
247                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
248                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
               fi  
249              fi              fi
250          #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2            # eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
251          done            done
252          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`          fi
253          if test $tst != 1 ; then          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
254            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2          if test $tst != 1 ; then
255                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
256            echo "==> WARNING: in checked list:" $listVar 1>&2                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
257          #- put it back once:            echo "==> WARNING: in checked list:" $listVar 1>&2
258            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`          #- put it back once:
259          fi            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
260            fi
261          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
262          echo "listVar='$listVar'" >> $locDIR"/summary.txt"          echo "listVar='$listVar'" >> $locDIR"/summary.txt"
263          #---          #---
264          allargs=""          allargs=""
265          for xx in $listVar          for xx in $listVar
266          do          do
267            case $xx in            case $xx in
268             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
269                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
270                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $refoutp ; yy=$?
271                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
272            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  ref_cost_function" "ADM CostFct" $2 $refoutp ; yy=$? ;;
273            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;           'AdGrd') testoutput_var $1 "ADM  adjoint_gradient"  "ADM Ad Grad" $2 $refoutp ; yy=$? ;;
274             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;           'FDGrd') testoutput_var $1 "ADM  finite-diff_grad"  "ADM FD Grad" $2 $refoutp ; yy=$? ;;
275             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;          'tlmCst') testoutput_var $1 "TLM  ref_cost_function" "TLM CostFct" $2 $refoutp ; yy=$? ;;
276             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;          'tlmGrd') testoutput_var $1 "TLM  tangent-lin_grad"  "TLM TL Grad" $2 $refoutp ; yy=$? ;;
277             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;          'fwdGrd') testoutput_var $1 "TLM  finite-diff_grad"  "TLM FD Grad" $2 $refoutp ; yy=$? ;;
278             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $refoutp ; yy=$? ;;
279             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $refoutp ; yy=$? ;;
280             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $refoutp ; yy=$? ;;
281             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $refoutp ; yy=$? ;;
282             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $refoutp ; yy=$? ;;
283             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $refoutp ; yy=$? ;;
284             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $refoutp ; yy=$? ;;
285             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $refoutp ; yy=$? ;;
286             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $refoutp ; yy=$? ;;
287             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $refoutp ; yy=$? ;;
288             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $refoutp ; yy=$? ;;
289             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $refoutp ; yy=$? ;;
290               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $refoutp ; yy=$? ;;
291               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $refoutp ; yy=$? ;;
292               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $refoutp ; yy=$? ;;
293               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $refoutp ; yy=$? ;;
294          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
295             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $refoutp ; yy=$? ;;
296          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
297             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $refoutp ; yy=$? ;;
298          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
299             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $refoutp ; yy=$? ;;
300          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
301             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $refoutp ; yy=$? ;;
302           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $refoutp ; yy=$? ;;
303           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $refoutp ; yy=$? ;;
304           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $refoutp ; yy=$? ;;
305           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $refoutp ; yy=$? ;;
306           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $refoutp ; yy=$? ;;
307           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $refoutp ; yy=$? ;;
308           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $refoutp ; yy=$? ;;
309           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $refoutp ; yy=$? ;;
310           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $refoutp ; yy=$? ;;
311           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $refoutp ; yy=$? ;;
312           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $refoutp ; yy=$? ;;
313           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $refoutp ; yy=$? ;;
314          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;           'uSImn') testoutput_var $1 "seaice_uice_min"   "SIce Uice min"   $2 $refoutp ; yy=$? ;;
315          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;           'uSImx') testoutput_var $1 "seaice_uice_max"   "SIce Uice max"   $2 $refoutp ; yy=$? ;;
316          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;           'uSIav') testoutput_var $1 "seaice_uice_mean"  "SIce Uice mean"  $2 $refoutp ; yy=$? ;;
317          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;           'uSIsd') testoutput_var $1 "seaice_uice_sd"    "SIce Uice StDv"  $2 $refoutp ; yy=$? ;;
318          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;           'vSImn') testoutput_var $1 "seaice_vice_min"   "SIce Vice min"   $2 $refoutp ; yy=$? ;;
319          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;           'vSImx') testoutput_var $1 "seaice_vice_max"   "SIce Vice max"   $2 $refoutp ; yy=$? ;;
320                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;           'vSIav') testoutput_var $1 "seaice_vice_mean"  "SIce Vice mean"  $2 $refoutp ; yy=$? ;;
321            esac           'vSIsd') testoutput_var $1 "seaice_vice_sd"    "SIce Vice StDv"  $2 $refoutp ; yy=$? ;;
322            if test $xx = $sVar          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $refoutp ; yy=$? ;;
323            then allargs="$allargs > $yy <"          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $refoutp ; yy=$? ;;
324            else allargs="$allargs $yy"          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $refoutp ; yy=$? ;;
325            fi          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Glob-ave"  $2 $refoutp ; yy=$? ;;
326          done          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South-av"  $2 $refoutp ; yy=$? ;;
327            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North-av"  $2 $refoutp ; yy=$? ;;
328            'HthMxS') testoutput_var $1 "thSI_IceH_max_S" "thSIc H South-max" $2 $refoutp ; yy=$? ;;
329            'HthMxN') testoutput_var $1 "thSI_IceH_max_N" "thSIc H North-max" $2 $refoutp ; yy=$? ;;
330            'StrmIc') testoutput_var $1 "STREAMICE_FP_ERR" "StreamIce Solver" $2 $refoutp ; yy=$? ;;
331                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
332              esac
333              if test $xx = $sVar
334              then allargs="$allargs > $yy <"
335              else allargs="$allargs $yy"
336              fi
337            done
338    
339          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
340          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
341          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
342            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
343            echo $allargs $adNul            echo $allargs $adNul
344          else          else
345            echo $allargs            echo $allargs
346          fi          fi
347  # <-- same processing for adjoint & forward test  # <-- same processing for adjoint & forward test
# Line 328  genmakemodel() Line 364  genmakemodel()
364              if test "x$MKDEPEND" != x ; then              if test "x$MKDEPEND" != x ; then
365                  command="$command -makedepend=$MKDEPEND"                  command="$command -makedepend=$MKDEPEND"
366              fi              fi
367              if test "x$ADM" = xt ; then              if test $KIND = 1 -o $KIND = 2 ; then
368                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
369              elif test "x$OADM" = xt ; then              elif test $KIND = 4 ; then
370                  command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"                  command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
371              else              else
372                  command="$command -mods=../code"                  command="$command -mods=../code"
# Line 338  genmakemodel() Line 374  genmakemodel()
374              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
375                  command="$command -optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
376              fi              fi
377              if test "x$IEEE" != x ; then              if test $OptLev = 1 ; then
378                  command="$command -ieee"                  command="$command -ieee"
379              fi              fi
380                if test $OptLev = 0 ; then
381                    command="$command -devel"
382                fi
383              if test "x$GSL" = xt ; then              if test "x$GSL" = xt ; then
384                  command="$command -gsl"                  command="$command -gsl"
385              fi              fi
# Line 354  genmakemodel() Line 393  genmakemodel()
393              if test "x$USE_R4" = xt ; then              if test "x$USE_R4" = xt ; then
394                  command="$command -use_r4"                  command="$command -use_r4"
395              fi              fi
396                if test "x$EXTRFLG" != x ; then
397                    command="$command -extra_flag $EXTRFLG"
398                fi
399              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
400                  command="$command -ts"                  command="$command -ts"
401              fi              fi
# Line 425  run_clean() Line 467  run_clean()
467              find . -name "fort.*" -exec rm {} \;              find . -name "fort.*" -exec rm {} \;
468              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
469              #- should remove executable only if sym-link (alredy done above)              #- should remove executable only if sym-link (alredy done above)
470              rm -f $RUNLOG *.txt STD* *diagnostics.log datetime              rm -f $RUNLOG *.txt STD* w2_tile_topology.????.log *diagnostics.log datetime
471              rm -rf mnc_test_*              rm -rf mnc_test_*
472              rm -f *_MIT_CE_000.opt0000 costfunction*0000              rm -f *_MIT_CE_000.opt0000 costfunction*0000
473                rm -f oad_cp.000.[0-9][0-9][0-9][0-9][0-9]
474              echo successful              echo successful
475              exit 0              exit 0
476          )          )
# Line 474  makemodel() Line 517  makemodel()
517          cd $1;          cd $1;
518          if test -r Makefile ; then          if test -r Makefile ; then
519              printf 'make ... '              printf 'make ... '
520              if test "x$ADM" = xt ; then              if test "x$REPLMAKE" = x ; then
521                  $MAKE adall >> make.tr_log 2>&1                  $MAKE $TARG >> make.tr_log 2>&1
522              elif test "x$OADM" = xt ; then              else
523                  $MAKE adAll >> make.tr_log 2>&1                  $REPLMAKE $TARG >> make.tr_log 2>&1
             else  
                 if test "x$JOBS" = x ; then  
                     $MAKE >> make.tr_log 2>&1  
                 else  
                     $MAKE -j $JOBS >> make.tr_log 2>&1  
                 fi  
524              fi              fi
525              RETVAL=$?              RETVAL=$?
526              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
527                  tail make.tr_log                  tail make.tr_log
528                  echo failed                  echo failed
529                  cp make.tr_log genmake.log genmake.tr_log $CDIR                  cp genmake.log genmake.tr_log $CDIR
530                    tail -$NBLINES_MKLOG make.tr_log > $CDIR"/make.tr_log_tail"
531                  rm -f $EXECUTABLE                  rm -f $EXECUTABLE
532                  mk_fail=1                  mk_fail=1
533              else              else
# Line 500  makemodel() Line 538  makemodel()
538              mk_fail=2              mk_fail=2
539          fi          fi
540      fi      fi
541      if test "x$ADM" = xt -a -f taf_ad.log ; then      if test $KIND = 1 -a -f taf_ftl.log ; then
542              head -1 taf_ad.log >> $CDIR"/summary.txt"          head -1 taf_ftl.log >> $CDIR"/summary.txt"
543              nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`      fi
544              nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`      if test $KIND = 2 -a -f taf_ad.log ; then
545              echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \          head -1 taf_ad.log >> $CDIR"/summary.txt"
546            nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`
547            nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`
548            if test -f taf_output ; then
549                n2er=`grep -c 'TAF *.* ERROR ' taf_output`
550                nerr=`expr $nerr + $n2er`
551            fi
552            echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \
553                                  >> $CDIR"/summary.txt"                                  >> $CDIR"/summary.txt"
554      fi      fi
555      if test $mk_fail != 0 ; then return $mk_fail ; fi      if test $mk_fail != 0 ; then return $mk_fail ; fi
# Line 513  makemodel() Line 558  makemodel()
558    
559  mk_mpi_size()  mk_mpi_size()
560  {  {
561      # mk_mpi_size input_file output_file proc_Nb prefer_to_split_X      # mk_mpi_size input_file output_file proc_Nb threads_Nb_X threads_Nb_Y
562      #      #
563      # make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)      #  make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)
564      #     for an MPI build with no more than proc_Nb processors ;      #     for an MPI build with no more than proc_Nb processors ;
565      # return the effective number of processors.      #  ensure that enough tiles per proc (nSx,nSy) remain for the given
566        #     number of threads (nTx,nTy) ;
567        #  return the effective number of processors.
568    
569      inp=$1      inp=$1
570      out=$2      out=$2
571      np=$3      np=$3
572      dirX=$4      tx=$4
573        ty=$5
574      tmp=TTT.$$      tmp=TTT.$$
575    
576        # dirX : select with direction to favor in MPI process repartition
577        #   dirX=1 : prefer to put more proc in X direction
578        #   dirX=0 : prefer to put more proc in Y direction
579        dirX=0
580    
581      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`
582      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`
583      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`
584      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`
585    
586        #- for each direction, assume # of threads is a multiple of total number of tiles
587        nx=$px
588        if [ `expr $sx % $tx` -ne 0 -a `expr $sx \* $px % $tx` -eq 0 ] ; then
589            nx=`expr $sx \* $px / $tx`
590            if [ $verbose -gt 1 ]; then
591                echo " change px from $px to $nx to accommodate $tx threads"
592            fi
593        fi
594        ny=$py
595        if [ `expr $sy % $ty` -ne 0 -a `expr $sy \* $py % $ty` -eq 0 ] ; then
596            ny=`expr $sy \* $py / $ty`
597            if [ $verbose -gt 1 ]; then
598                echo " change py from $py to $ny to accommodate $ty threads"
599            fi
600        fi
601      #- find the largest divisor of input_file proc Nb, but not larger than $np      #- find the largest divisor of input_file proc Nb, but not larger than $np
602      pp=0      pp=0
603      i=1      i=1
604      while [ $i -le $px ] ; do      while [ $i -le $nx ] ; do
605        if [ `expr $px % $i` -eq 0 ] ; then        if [ `expr $nx % $i` -eq 0 ] ; then
606          j=1          j=1
607          while [ $j -le $py ] ; do          while [ $j -le $ny ] ; do
608            if [ `expr $py % $j` -eq 0 ] ; then            if [ `expr $ny % $j` -eq 0 ] ; then
609              ij=`expr $i \* $j`              ij=`expr $i \* $j`
610              if [ $ij -gt $pp ] ; then              if [ $ij -gt $pp ] ; then
611                  flag=1                  flag=1
# Line 630  linkdata() Line 698  linkdata()
698          (          (
699              cd $1 ; shift              cd $1 ; shift
700              echo 'linkdata from dirs:' $*              echo 'linkdata from dirs:' $*
701              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
702              for xx in $inpMPI ; do              for xx in $inpMPI ; do
703                if test -r "../"$1"/"$xx ; then                if test -r "../"$1"/"$xx ; then
704                  # found 1 _mpi sfx file in 1rst input dir and it is readable                  # found 1 _mpi sfx file in 1rst input dir and it is readable
705                  yy=`echo $xx | sed 's:\.mpi$::'`                  yy=`echo $xx | sed 's:\.mpi$::'`
706                  if test "x$MPI" = "x0" ; then                  if test "x$MPI" = "x0" ; then
707                      # not mpi test: remove symbolic link                      # not mpi test: remove symbolic link
# Line 665  linkdata() Line 733  linkdata()
733              prevDir='NONE'              prevDir='NONE'
734              for ldir in $* ; do              for ldir in $* ; do
735                  if test -d "../"$ldir -a $ldir != $prevDir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
736                      printf " ldir=${ldir}:" 1>&2                      printf " ldir=${ldir}:" 1>&2
737                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
738                      for i in $files ; do                      for i in $files ; do
739                          if test ! -d "../"$ldir/$i ; then                          if test ! -d "../"$ldir/$i ; then
# Line 713  runmodel() Line 781  runmodel()
781            else rm -f $EXECUTABLE            else rm -f $EXECUTABLE
782            fi            fi
783          fi          fi
784          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
785              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
786              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
787          fi          fi
788          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
789              rm -f $RUNLOG ; touch $RUNLOG              rm -f $RUNLOG ; touch $RUNLOG
790              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
791              echo " no executable:" $EXECUTABLE >> $RUNLOG              echo " no executable:" $EXECUTABLE >> $RUNLOG
792              RETVAL=8              RETVAL=8
793              ENDVAL=-1              ENDVAL=-1
794          else          else
795            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
796              # output do not exist or is older than executable:              # output do not exist or is older than executable:
797              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG
798              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
799            #- Divided Adjoint Run:
800            #  get the number of additional runs (add_DIVA_runs) from file "run_ADM_DIVA"
801                if test $KIND = 2 -a -f run_ADM_DIVA ; then
802                  adm_diva_nb=`sed -n '/^ *add_DIVA_runs\>.*=/p' run_ADM_DIVA | sed 's/ //g'`
803                  echo " Divided Adjoint Run: $adm_diva_nb" >> $RUNLOG
804                  eval "let $adm_diva_nb"
805                  if [ $add_DIVA_runs -ge 1 ] ; then
806                    rm -f costf* divided.ctrl snapshot*
807                    echo -n "(add_DIVA_runs=$add_DIVA_runs) ... "
808                    for ii in `seq 1 $add_DIVA_runs` ; do
809                      ( eval $COMMAND ) >> $RUNLOG 2>&1
810                      echo " additional DIVA run # $ii : done" >> $RUNLOG
811                      mv -f $OUTPUTFILE ${OUTPUTFILE}.diva_${ii}
812                    done
813                  fi
814                fi
815            #- special DIVA processing ends here
816              ( eval $COMMAND ) >> $RUNLOG 2>&1              ( eval $COMMAND ) >> $RUNLOG 2>&1
817              RETVAL=$?              RETVAL=$?
818              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
# Line 741  runmodel() Line 826  runmodel()
826              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
827              touch $RUNLOG              touch $RUNLOG
828              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
829              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
830            fi            fi
831          fi          fi
832          rm -f run.log_tmp          rm -f run.log_tmp
833          #- in all cases where OutputFile exists, report SIZE (and AD time)          #- in all cases where OutputFile exists, report SIZE and time
834          if test -f $OUTPUTFILE ; then          if test -f $OUTPUTFILE ; then
835            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \
836                  | sed 's/(PID.TID 0000.0001)     //' >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
837            if test "x$ADM" = xt ; then            grep -A3 'Seconds in section "ALL' $OUTPUTFILE \
838              grep -A3 'Seconds in section "ALL' $OUTPUTFILE >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
           fi  
839          fi          fi
840          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
841          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
# Line 853  formatresults() Line 937  formatresults()
937          fi          fi
938      fi      fi
939      printf '  %s' $nm      printf '  %s' $nm
940        if test $KIND = 2 ; then
941            #-- apppend taf repport summary:
942            tafrep=`grep -c '^ TAF reports ' $CDIR/summary.txt`
943            if test $tafrep = 1 ; then
944                grep '^ TAF reports ' $CDIR/summary.txt | awk '{printf "  (e=%i, w=%i)",$3,$6}'
945            fi
946        fi
947      printf '\n'      printf '\n'
948    
949  }  }
# Line 861  scandirs() Line 952  scandirs()
952  {  {
953      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
954          for arg in * ; do          for arg in * ; do
955              test -f $arg/$1 && echo $arg             #test -f $arg/$1 && echo $arg
956                test -f $arg/$1 -o -f $arg/$1.gz && echo $arg
957          done          done
958      else      else
959          echo $*          echo $*
# Line 915  check_eedata() Line 1007  check_eedata()
1007  #  Default properties  #  Default properties
1008  debug=0  debug=0
1009  verbose=1  verbose=1
1010    NBLINES_MKLOG=16000
1011    
1012  IEEE=true  OptLev=1
 if test "x$MITGCM_IEEE" != x ; then  
     IEEE=$MITGCM_IEEE  
 fi  
1013  GSL=f  GSL=f
1014    
1015  CLEANUP=f  CLEANUP=f
# Line 944  MKDEPEND= Line 1034  MKDEPEND=
1034  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1035      MAKE=make      MAKE=make
1036  fi  fi
1037    REPLMAKE=
1038  if test "x$CC" = x ; then  if test "x$CC" = x ; then
1039      CC=cc      CC=cc
1040  fi  fi
1041  JOBS=  JOBS=
1042    TARG=
1043  MPI=0  MPI=0
1044  MPI_MFILE=  MPI_MFILE=
1045  MULTI_THREAD=f  MULTI_THREAD=f
1046  OUTDIR=  OUTDIR=
1047  DELDIR=  DELDIR=
1048  USE_R4=  USE_R4=
1049    EXTRFLG=
1050    
1051  ADM=  #- type of testing (KIND):
1052  OADM=  #   KIND=0 : forward (= default) ;  KIND=1 : Tangent Linear with TAF ;
1053    #   KIND=2 : Adjoint with TAF ;     KIND=4 : Adjoint with OpenAD
1054    KIND=0
1055    
1056  # list of pTracers to check for monitor output  # list of pTracers to check for monitor output
1057  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
# Line 1006  for ac_option ; do Line 1101  for ac_option ; do
1101          -make | --make | -m | --m) ac_prev=MAKE ;;          -make | --make | -m | --m) ac_prev=MAKE ;;
1102          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;
1103    
1104            -repl_mk | --repl_mk ) ac_prev=REPLMAKE ;;
1105            -repl_mk=* | --repl_mk=*) REPLMAKE=$ac_optarg ;;
1106    
1107          -odir | --odir) ac_prev=OUTDIR ;;          -odir | --odir) ac_prev=OUTDIR ;;
1108          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;
1109    
# Line 1018  for ac_option ; do Line 1116  for ac_option ; do
1116          -j | --j) ac_prev=JOBS ;;          -j | --j) ac_prev=JOBS ;;
1117          -j=* | --j=*) JOBS=$ac_optarg ;;          -j=* | --j=*) JOBS=$ac_optarg ;;
1118    
1119            -ef | --ef) ac_prev=EXTRFLG ;;
1120            -ef=* | --ef=*) EXTRFLG=$ac_optarg ;;
1121    
1122          -clean | --clean) CLEANUP=t ; DELDIR=t ;;          -clean | --clean) CLEANUP=t ; DELDIR=t ;;
1123    
1124          -norun | --norun | -nr | --nr) NORUN=t ;;          -norun | --norun | -nr | --nr) NORUN=t ;;
1125            -obj | --obj ) TARG='obj' ; NORUN=t ;;
1126          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;
1127          -quick | --quick | -q | --q) QUICK=t ;;          -quick | --quick | -q | --q) QUICK=t ;;
1128          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;
# Line 1039  for ac_option ; do Line 1141  for ac_option ; do
1141    
1142          -mth) MULTI_THREAD=t ;;          -mth) MULTI_THREAD=t ;;
1143    
1144          -adm | -ad) ADM=t ;;          -tlm) if test $KIND = 0 ; then KIND=1 ; else
1145          -oad) OADM=t; NODEPEND=t ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1146                  fi ;;
1147          -ieee) IEEE=true ;;          -adm | -ad) if test $KIND = 0 ; then KIND=2 ; else
1148          -noieee) IEEE= ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1149                  fi ;;
1150            -oad) if test $KIND = 0 ; then KIND=4 ; NODEPEND=t ; else
1151                    echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1152                  fi ;;
1153    
1154            -ieee)   echo "Warning: ignore option '-ieee' (already the default)"
1155                     printf " ... " ;;
1156            -noieee) echo "Warning: will use option '-fast' instead of '-noieee' (obsolete)"
1157                     printf " ... " ; OptLev=`expr $OptLev \* 2` ;;
1158            -fast)  OptLev=`expr $OptLev \* 2` ;;
1159            -devel) OptLev=0 ;;
1160          -gsl) GSL=t ;;          -gsl) GSL=t ;;
1161    
1162          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
# Line 1078  if test "x$MPI" != x0 -a "x$MPI_MFILE" ! Line 1191  if test "x$MPI" != x0 -a "x$MPI_MFILE" !
1191      if test -r $MPI_MFILE ; then      if test -r $MPI_MFILE ; then
1192          nl=`wc -l $MPI_MFILE | awk '{print $1}'`          nl=`wc -l $MPI_MFILE | awk '{print $1}'`
1193          if [ $nl -lt $MPI ] ; then          if [ $nl -lt $MPI ] ; then
1194            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"
1195            usage            usage
1196          fi          fi
1197          if [ $verbose -gt 1 ]; then          if [ $verbose -gt 1 ]; then
1198              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"
1199          fi          fi
1200      else      else
1201            echo "Error: cannot access MPI_MFILE=$MPI_FILE"            echo "Error: cannot access MPI_MFILE=$MPI_FILE"
1202            usage            usage
1203      fi      fi
1204  fi  fi
1205    
1206  #- setting for forward or ADM testing  #- setting for forward or ADM testing
1207  if test "x$ADM" = xt ; then  if test $KIND = 1 ; then
1208        TARG=ftlall
1209        code_dir=code_ad
1210        inputdir=input_ad
1211        ref_outp="output_tlm.txt"
1212        EXECUTABLE="mitgcmuv_ftl"
1213    elif test $KIND = 2 ; then
1214        if test "x$TARG" = xobj ; then TARG=adobj ; else TARG=adall ; fi
1215      code_dir=code_ad      code_dir=code_ad
1216      inputdir=input_ad      inputdir=input_ad
1217      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
1218      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1219  elif test "x$OADM" = xt ; then  elif test $KIND = 4 ; then
1220        TARG=adAll
1221      code_dir=code_oad      code_dir=code_oad
1222      inputdir=input_oad      inputdir=input_oad
1223      ref_outp="output_oadm.txt"      ref_outp="output_oadm.txt"
1224      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1225  else  else
1226        if test "x$JOBS" != x ; then TARG="-j $JOBS $TARG" ; fi
1227      code_dir=code      code_dir=code
1228      inputdir=input      inputdir=input
1229      ref_outp="output.txt"      ref_outp="output.txt"
# Line 1145  do Line 1267  do
1267              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1268          fi          fi
1269      else      else
1270          if test $count = 1 ; then echo -n ", \"$xx\""          if test $count = 1 ; then echo -n ", \"$xx\""
1271          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1272          fi          fi
1273      fi      fi
# Line 1173  echo "OK (COMMAND= $COMMAND )" Line 1295  echo "OK (COMMAND= $COMMAND )"
1295  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1296  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1297  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1298  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 1 ; then
1299        DEF_CHECK_LIST='tlmGrd tlmCst tlmGrd fwdGrd'
1300        EMPTY_RESULTS='.. .. ..'
1301        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1302    elif test $KIND = 2 -o $KIND = 4 ; then
1303        DEF_CHECK_LIST='AdGrd Cost AdGrd FDGrd'
1304        EMPTY_RESULTS='.. .. ..'
1305        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1306    else
1307      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1308      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1309      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1310      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1311      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
 else  
     DEF_CHECK_LIST='Grad Cost Grad'  
     EMPTY_RESULTS='.. ..'  
     LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`  
1312  fi  fi
1313    
1314  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1315  if test -x tr_cmpnum ; then  if test "x$CLEANUP" = xt -o -x tr_cmpnum ; then
1316      echo "skipping comparison code build"      echo "skipping comparison code build"
1317  else  else
1318      createcodelet      createcodelet
# Line 1202  fi Line 1328  fi
1328  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1329  CMDLINE=$0  CMDLINE=$0
1330  for xx in "$@" ; do nw=`echo $xx | wc -w`  for xx in "$@" ; do nw=`echo $xx | wc -w`
1331      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx" ; else
1332                          else CMDLINE="$CMDLINE '$xx'" ; fi        nb=`echo $xx | grep -c '='`
1333          if test $nb = 0 ; then CMDLINE="$CMDLINE '$xx'"
1334          else yy=`echo "$xx'" | sed "s/=/='/"` ;
1335                                 CMDLINE="$CMDLINE $yy" ; fi
1336        fi
1337  done  done
1338  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1339  MACH=`hostname`  MACH=`hostname`
# Line 1250  if test "x$OPTFILE" != xNONE ; then Line 1380  if test "x$OPTFILE" != xNONE ; then
1380          echo >> $SUMMARY          echo >> $SUMMARY
1381          echo "  OPTFILE=$OPTFILE" >> $SUMMARY          echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1382      else      else
1383          echo | tee $SUMMARY          echo | tee -a $SUMMARY
1384          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee -a $SUMMARY
1385          exit 1          exit 1
1386      fi      fi
1387  else  else
# Line 1261  else Line 1391  else
1391  fi  fi
1392  echo  echo
1393  echo >> $SUMMARY  echo >> $SUMMARY
1394  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 0 ; then
1395      if [ $MATCH_CRIT -lt 10 ] ;      line_0=`printf '%s %2i' 'default' $MATCH_CRIT`
     then line_0="default  "$MATCH_CRIT ;  
     else line_0="default "$MATCH_CRIT ; fi  
1396         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1397      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1398      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="e p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1399      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="n n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1400      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1401      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
1402          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
# Line 1277  if test "x$ADM" = x -a "x$OADM" = x; the Line 1405  if test "x$ADM" = x -a "x$OADM" = x; the
1405          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1406          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
1407      done      done
1408    else
1409        line_0=`printf '%s %2i' 'default   ' $MATCH_CRIT`
1410      if test $KIND = 1 ; then
1411       #echo "TANGLIN=true" >> $SUMMARY
1412        echo "TangLin generated by TAF" >> $SUMMARY
1413      elif test $KIND = 3 ; then
1414        echo "TangLin generated by OpenAD" >> $SUMMARY
1415      elif test $KIND = 2 ; then
1416       #echo "ADJOINT=true" >> $SUMMARY
1417        echo "Adjoint generated by TAF" >> $SUMMARY
1418      else
1419        echo "Adjoint generated by OpenAD" >> $SUMMARY
1420      fi
1421      if test $KIND = 1 -o $KIND = 3 ; then
1422        line_1="G D M    C  T  F"
1423        line_2="e p a R  o  L  D"
1424      else
1425        line_1="G D M    C  A  F"
1426        line_2="e p a R  o  d  D"
1427      fi
1428        line_3="n n k u  s  G  G"
1429        line_4="2 d e n  t  r  r"
1430        echo >> $SUMMARY
1431    fi
1432    if test "x$CLEANUP" != xt ; then
1433      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1434      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
1435      echo "$line_2" | tee -a $SUMMARY      echo "$line_2" | tee -a $SUMMARY
1436      echo "$line_3" | tee -a $SUMMARY      echo "$line_3" | tee -a $SUMMARY
1437      echo "$line_4" | tee -a $SUMMARY      echo "$line_4" | tee -a $SUMMARY
1438      echo " "       | tee -a $SUMMARY      echo ""        | tee -a $SUMMARY
 else  
     echo "ADJOINT=true" >> $SUMMARY  
     echo >> $SUMMARY  
     if [ $MATCH_CRIT -lt 10 ] ;  
     then line_0="default     "$MATCH_CRIT ;  
     else line_0="default    "$MATCH_CRIT ; fi  
     echo "$line_0" | tee -a $SUMMARY  
     cat << EOF | tee -a $SUMMARY  
 G D M    C  G  
 E p a R  o  r  
 N n k u  s  a  
 2 d e n  t  d  
   
 EOF  
1439  fi  fi
1440  echo "-------------------------------------------------------------------------------"  echo "-------------------------------------------------------------------------------"
1441    
# Line 1324  for dir in $TESTDIRS ; do Line 1463  for dir in $TESTDIRS ; do
1463              rm -f SIZE.h.mpi genmake.tr_log make.tr_log              rm -f SIZE.h.mpi genmake.tr_log make.tr_log
1464          )          )
1465          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1466              echo -n '  --- dir:' $dir/$rundir ': '              echo -n '  --- dir:' $dir/$rundir ': '
1467              run_clean $dir/$rundir              run_clean $dir/$rundir
1468          fi          fi
1469          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`
# Line 1339  for dir in $TESTDIRS ; do Line 1478  for dir in $TESTDIRS ; do
1478      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1479      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1480      fout=$dir"/results/"$ref_outp      fout=$dir"/results/"$ref_outp
1481      if test ! -r $fout ; then     #if test ! -r $fout ; then
1482        if test ! -r $fout -a ! -r ${fout}.gz ; then
1483          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1484          continue          continue
1485      fi      fi
# Line 1356  for dir in $TESTDIRS ; do Line 1496  for dir in $TESTDIRS ; do
1496      fi      fi
1497    
1498      if test "x$MPI" != "x0" ; then      if test "x$MPI" != "x0" ; then
1499          prefer_X=0          ntx=1 ; nty=1
1500          if test "x$MULTI_THREAD" = "xt" ; then          if test "x$MULTI_THREAD" = "xt" ; then
1501              retv=`check_eedata $dir"/input/eedata.mth"`            ff=$dir"/input/eedata.mth"
1502              if test $retv = 1 ; then prefer_X=1 ; fi            ntx=`grep "^ *nTx *=" $ff | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
1503              nty=`grep "^ *nTy *=" $ff | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
1504              if test "x$ntx" = x ; then ntx=1 ; fi
1505              if test "x$nty" = x ; then nty=1 ; fi
1506          fi          fi
1507          #- create new SIZE.h with no more than '$MPI' Procs          #- create new SIZE.h with no more than '$MPI' Procs
1508          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $prefer_X          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $ntx $nty
1509          LOC_NPROC=$?          LOC_NPROC=$?
1510          (   cd $BUILD_DIR          (   cd $BUILD_DIR
1511              if test -r SIZE.h.mpi ; then              if test -r SIZE.h.mpi ; then
# Line 1402  for dir in $TESTDIRS ; do Line 1545  for dir in $TESTDIRS ; do
1545      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1546      extra_runs=      extra_runs=
1547      if test "x$NORUN" = xf ; then      if test "x$NORUN" = xf ; then
1548          ex_run_dirs=`( cd $dir ; echo $inputdir.* )`          ex_run_dirs=`( cd $dir ; ls -d $inputdir.* 2> /dev/null )`
1549      fi      fi
1550      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1551      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1552          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1553          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1554          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1555          if test -f $outf -a -r $outf ; then          if test -r $outf -o -r ${outf}.gz ; then
1556            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1557              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1558                if test "x$MPI" = "x0" ; then                if test "x$MPI" = "x0" ; then
# Line 1432  for dir in $TESTDIRS ; do Line 1575  for dir in $TESTDIRS ; do
1575    
1576      echo      echo
1577      if test "x$extra_runs" = "x" ; then      if test "x$extra_runs" = "x" ; then
1578         echo "Experiment:  $dir"          echo "Experiment:  $dir"
1579      else      else
1580         echo "Experiment:  $dir ; extra_runs=$extra_runs"          echo "Experiment:  $dir ; extra_runs=$extra_runs"
1581      fi      fi
1582      echo      echo
1583      unset genmake makedepend make run      unset genmake makedepend make run
# Line 1453  for dir in $TESTDIRS ; do Line 1596  for dir in $TESTDIRS ; do
1596              run=N              run=N
1597          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1598              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1599              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1600              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1601              && makemodel $dir/$builddir && make=Y              && makemodel $dir/$builddir && make=Y
1602      else      else
1603          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1604              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1605              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1606              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1607              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1608              && run_clean $dir/$rundir \              && run_clean $dir/$rundir \
# Line 1471  for dir in $TESTDIRS ; do Line 1614  for dir in $TESTDIRS ; do
1614    
1615          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1616          echo 1>&2          echo 1>&2
1617          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1618          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1619    
1620          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1621              unset run              unset run
1622              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1623              #  reference output file              #  reference output file
1624              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1625              #  Create an output dir & summary.txt file for each extra run (tdir.ex)              #  Create an output dir & summary.txt file for each extra run (tdir.ex)
# Line 1492  for dir in $TESTDIRS ; do Line 1635  for dir in $TESTDIRS ; do
1635              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir
1636              runmodel $dir/$pfxdir.$ex && run=Y \              runmodel $dir/$pfxdir.$ex && run=Y \
1637              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`
1638              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir.$ex ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
             fres="$fres.$ex"  
1639              echo 1>&2              echo 1>&2
1640              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1641              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
# Line 1502  for dir in $TESTDIRS ; do Line 1644  for dir in $TESTDIRS ; do
1644              fi              fi
1645          done          done
1646    
1647      if test -f $DRESULTS"/"genmake_state ; then : ; else      if test ! -f $DRESULTS"/"genmake_state ; then
1648          if test -f $dir/$builddir/Makefile ; then          if test -f $dir/$builddir/Makefile ; then
1649              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`
1650              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state
# Line 1511  for dir in $TESTDIRS ; do Line 1653  for dir in $TESTDIRS ; do
1653              if test "x$OPTFILE" = xNONE ; then              if test "x$OPTFILE" = xNONE ; then
1654                  eval $mkOpt                  eval $mkOpt
1655                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\
1656                          $SUMMARY > tr_0.tmp_log                          $SUMMARY > tmp.tr_log
1657                  RETVAL=$?                  RETVAL=$?
1658                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY
1659                          cp tr_0.tmp_log $SUMMARY                          cp tmp.tr_log $SUMMARY
1660                  else rm -f tr_0.tmp_log                  else rm -f tmp.tr_log
1661                  fi                  fi
1662              fi              fi
1663              gmkLog=$dir/$builddir/genmake.log              gmkLog=$dir/$builddir/genmake.log
1664              grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1              if test -r $gmkLog ; then
1665              RETVAL=$?                  grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1
1666              if test "x$RETVAL" = x0 ; then                  RETVAL=$?
1667                  echo "from '$gmkLog', extract compiler version:" >> $DRESULTS/genmake_state                  if test "x$RETVAL" = x0 ; then
1668                  sed -n '/Get compiler version/,/<-- compiler version/p' $gmkLog \                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1669                         | grep -v '^... compiler version ' > tr_1.tmp_log                    echo "extract compiler version:"   >> $DRESULTS/genmake_state
1670                  sed -n '1,/^$/p' tr_1.tmp_log | sed '/^$/d' | sed 's/^./ &/' \                    sed -n '/Get compiler version/,/<-- compiler version/p' \
1671                          >> $DRESULTS/genmake_state                       $gmkLog | grep -v '^... compiler version ' > tmp.tr_log
1672                  rm -f tr_1.tmp_log                    sed -n '1p' tmp.tr_log >> $DRESULTS/genmake_state
1673                      sed -n '2,/^$/p' tmp.tr_log | sed '/^$/d' | sed 's/^./ &/' \
1674                                             >> $DRESULTS/genmake_state
1675                      rm -f tmp.tr_log
1676                    fi
1677                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1678                    echo "get NETCDF & LAPACK settings:" >> $DRESULTS/genmake_state
1679                    sed -n '/set HAVE_NETCDF=/p' $gmkLog >> $DRESULTS/genmake_state
1680                    sed -n '/set HAVE_LAPACK=/p' $gmkLog >> $DRESULTS/genmake_state
1681              fi              fi
1682          fi          fi
1683      fi      fi
1684      #postclean $dir/$builddir      #postclean $dir/$builddir
1685      if test "x$POSTCLEAN" = x2 ; then      if test "x$POSTCLEAN" = x2 ; then
1686          makeclean $dir/$builddir \          makeclean $dir/$builddir \
1687              && run_clean $dir/$rundir              && run_clean $dir/$rundir
1688      fi      fi
1689      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi
1690    
# Line 1581  fi Line 1731  fi
1731  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1732      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1733      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1734          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1735      fi      fi
1736      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1737  fi  fi
# Line 1589  fi Line 1739  fi
1739  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then
1740      rm -rf $DRESULTS      rm -rf $DRESULTS
1741  fi  fi
1742    echo "======== End of testreport execution ========"

Legend:
Removed from v.1.162  
changed lines
  Added in v.1.188

  ViewVC Help
Powered by ViewVC 1.1.22